'==============================================================================
'
'   EPBNOTE2.BAS for PowerBASIC for Windows PB/WIN 7.0
'
'   Encrypted PBNOTE2 with PC1 Cipher 128-bit keys
'   Output of the cipher is BINARY
'   Output is same length as input
'   You can open an encrypted document or a text document (choose All Files)
'   You can only save an encrypted document, if you want use decrypted text
'   Use copy and paste the text to an other application
'
'   Copyright (c) 1997,1999,2001,2002 PowerBASIC, Inc.
'
'   A complete text editor, using MDI windows.
'
'   Note:  Windows 95 "thunks down" to the 16-bit GDI for edit boxes, so
'          edit boxes are limited to 64k in Windows 95.  Edit boxes in
'          Windows NT are unlimited in size.
'
'==============================================================================

'------------------------------------------------------------------------------
' Initial Declares - first eliminate unnecessary macros in COMMCTRL.INC
'------------------------------------------------------------------------------
%NOANIMATE         = 1  ' Animate control
%NOBUTTON          = 1  ' Button
%NOCOMBO           = 1  ' Combo box
%NOCOMBOEX         = 1  ' ComboBoxEx
%NODATETIMEPICK    = 1  ' Date/time picker
%NODRAGLIST        = 1  ' Drag list control
%NOEDIT            = 1  ' Edit control
%NOFLATSBAPIS      = 1  ' Flat scroll bar
%NOHEADER          = 1  ' Header control
%NOHOTKEY          = 1  ' HotKey control
%NOIMAGELIST       = 1  ' Image APIs
%NOIPADDRESS       = 1  ' IP Address edit control
%NOLIST            = 1  ' List box control
%NOLISTVIEW        = 1  ' ListView control
%NOMENUHELP        = 1  ' Menu help
%NOMONTHCAL        = 1  ' MonthCal
%NOMUI             = 1  ' MUI
%NONATIVEFONTCTL   = 1  ' Native Font control
%NOPAGESCROLLER    = 1  ' Pager
%NOPROGRESS        = 1  ' Progress control
%NOREBAR           = 1  ' Rebar control
' %NOSTATUSBAR     = 1  ' Status bar
%NOTABCONTROL      = 1  ' Tab control
' %NOTOOLBAR       = 1  ' Tool bar
' %NOTOOLTIPS      = 1  ' Tool tips
%NOTRACKBAR        = 1  ' Track bar
%NOTRACKMOUSEEVENT = 1  ' Track Mouse Event
%NOTREEVIEW        = 1  ' TreeView
%NOUPDOWN          = 1  ' Up Down arrow control

'------------------------------------------------------------------------------
#COMPILE EXE
#RESOURCE "PBNOTE2.PBR"
#DIM ALL

'------------------------------------------------------------------------------
#INCLUDE "WIN32API.INC"
#INCLUDE "COMMCTRL.INC"
#INCLUDE "COMDLG32.INC"
#INCLUDE "MDI32.INC"

'------------------------------------------------------------------------------
%ID_TOOLBAR           = %WM_USER      + 1024&  ' toolbar
%ID_STATUSBAR         = %WM_USER      + 1025&  ' statusbar
%IDC_EDIT             = %WM_USER      + 1026&  ' edit control

' FILE
%IDM_NEW              = %WM_USER      + 2000&  ' New File
%IDM_OPEN             = %WM_USER      + 2001&  ' Open File
%IDM_SAVE             = %WM_USER      + 2005&  ' Save
%IDM_SAVEAS           = %WM_USER      + 2006&  ' Save As
%IDM_EXIT             = %WM_USER      + 2009&  ' Exit
%IDM_RECENT1          = %WM_USER      + 2010&  ' Recently opened file 1
%IDM_RECENT2          = %WM_USER      + 2011&  ' Recently opened file 2
%IDM_RECENT3          = %WM_USER      + 2012&  ' Recently opened file 3
%IDM_RECENT4          = %WM_USER      + 2013&  ' Recently opened file 4
%IDM_RECENT5          = %WM_USER      + 2014&  ' Recently opened file 5
%IDM_RECENT6          = %WM_USER      + 2015&  ' Recently opened file 6
%IDM_RECENT7          = %WM_USER      + 2016&  ' Recently opened file 7
%IDM_RECENT8          = %WM_USER      + 2017&  ' Recently opened file 8

' EDIT
%IDM_UNDO             = %WM_USER      + 2020&   ' Undo
%IDM_CUT              = %WM_USER      + 2022&   ' Cut
%IDM_COPY             = %WM_USER      + 2023&   ' Copy
%IDM_PASTE            = %WM_USER      + 2024&   ' Paste
%IDM_DELETE           = %WM_USER      + 2025&   ' Delete
%IDM_SELALL           = %WM_USER      + 2026&   ' Select all

' WINDOW
%IDM_CASCADE          = %WM_USER      + 2060&   ' Cascade windows
%IDM_TILEH            = %WM_USER      + 2061&   ' Tile windows horizontally
%IDM_TILEV            = %WM_USER      + 2062&   ' Tile windows vertically
%IDM_ARRANGE          = %WM_USER      + 2065&   ' Arrange icons
%IDM_CLOSE            = %WM_USER      + 2067&   ' Close all

' HELP
%IDM_ABOUT            = %WM_USER      + 2086&   ' About box

'------------------------------------------------------------------------------
GLOBAL hInst        AS DWORD
GLOBAL hMenu        AS DWORD
GLOBAL hMenuEdit    AS DWORD
GLOBAL hMenuFile    AS DWORD
GLOBAL hMenuReopen  AS DWORD
GLOBAL hMenuWindow  AS DWORD
GLOBAL hStatus      AS DWORD
GLOBAL hToolbar     AS DWORD
GLOBAL hWndMain     AS DWORD
GLOBAL hWndClient   AS DWORD
GLOBAL fClosed      AS LONG
GLOBAL freezeMenu   AS LONG
GLOBAL isNT         AS LONG
GLOBAL NewComCtl    AS LONG
GLOBAL NewDocNum    AS LONG
GLOBAL iniFile      AS ASCIIZ * %MAX_PATH

'-------------------------------------------------------
' Declarations for the PC1 encryption cipher

GLOBAL x1a0() AS LONG
GLOBAL cle() AS LONG
GLOBAL x1a2 AS LONG
GLOBAL inter AS LONG, res AS LONG, ax AS LONG, bx AS LONG
GLOBAL cx AS LONG, dx AS LONG, si AS LONG, tmp AS LONG
GLOBAL I AS LONG, c AS BYTE
GLOBAL password AS STRING
'--------------------------------------------------------

'------------------------------------------------------------------------------
DECLARE FUNCTION FileExist(BYVAL sfName AS STRING) AS LONG
DECLARE FUNCTION FileNam (BYVAL Src AS STRING) AS STRING
DECLARE FUNCTION FilePath (BYVAL Src AS STRING) AS STRING
DECLARE FUNCTION GetEdit () AS LONG
DECLARE FUNCTION InitComctl32 (BYVAL iccClasses AS DWORD ) AS LONG
DECLARE FUNCTION OpenThisFile(BYVAL fn AS STRING) AS DWORD
DECLARE SUB CenterWindow (BYVAL hWnd AS DWORD)
DECLARE SUB GetRecentFiles
DECLARE SUB HideButtons(BYVAL HideState AS LONG)
DECLARE SUB SaveFile (BYVAL Ask AS LONG)
DECLARE SUB WriteRecentFiles (BYVAL OpenFName AS STRING)

'PC1 encryption

DECLARE FUNCTION PC1ENC(encPassword AS STRING, encStringOut AS STRING) AS STRING
DECLARE FUNCTION PC1DEC(encPassword AS STRING, encStringIn AS STRING) AS STRING

'------------------------------------------------------------------------------
' The following DECLARE template is used for Explicit run-time linking
DECLARE FUNCTION zInitCommonControlsEx (icc AS INIT_COMMON_CONTROLSEX) AS LONG

'------------------------------------------------------------------------------
' Program entrance
'------------------------------------------------------------------------------
FUNCTION WINMAIN (BYVAL hInstance     AS DWORD, _
                  BYVAL hPrevInstance AS DWORD, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

  LOCAL hAccel       AS DWORD
  LOCAL pt           AS POINTAPI
  LOCAL Msg          AS TAGMSG
  LOCAL wce          AS WNDCLASSEX
  LOCAL vi           AS OSVERSIONINFO
  LOCAL szClassName  AS ASCIIZ * 80

  hInst = hInstance 'store module handle in global variable for later use

  GetModuleFileName hInst, iniFile, %MAX_PATH             ' get path to program
  iniFile = LEFT$(iniFile, INSTR(-1, iniFile, ANY "\/:")) ' this is same as AppPath
  iniFile = iniFile & "EPBNOTE2.INI"                       ' use AppPath for ini file

  ' Detect version of Windows - is it NT or Win95/98?
  vi.dwOsVersionInfoSize = SIZEOF(vi)
  GetVersionEx vi
  isNT = (vi.dwPlatformId = %VER_PLATFORM_WIN32_NT)

  ' Register Main Window Class
  szClassName       = "EPBNOTE2"
  wce.cbSize        = SIZEOF(wce)
  wce.style         = %CS_HREDRAW OR %CS_VREDRAW
  wce.lpfnWndProc   = CODEPTR(WndProc)
  wce.cbClsExtra    = 0
  wce.cbWndExtra    = 0
  wce.hInstance     = hInstance
  wce.hIcon         = LoadIcon(hInstance, "APPICON")
  wce.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
  wce.hbrBackground = %NULL
  wce.lpszMenuName  = %NULL
  wce.lpszClassName = VARPTR(szClassName)
  wce.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)

  IF RegisterClassEx(wce) = 0 THEN
      RegisterClass BYVAL (VARPTR(wce) + 4)
  END IF

  ' Register Code Window Class
  szClassName       = "EPBNOTE32"
  wce.cbSize        = SIZEOF(wce)
  wce.style         = %CS_DBLCLKS OR %CS_HREDRAW OR %CS_VREDRAW
  wce.lpfnWndProc   = CODEPTR(CodeProc)
  wce.cbClsExtra    = 0
  wce.cbWndExtra    = 4
  wce.hInstance     = hInst
  wce.hIcon         = LoadIcon(hInstance, "NOTEICON")
  wce.hCursor       = LoadCursor(%NULL, BYVAL %IDC_IBEAM)
  wce.hbrBackground = %NULL
  wce.lpszMenuName  = %NULL
  wce.lpszClassName = VARPTR(szClassName)
  wce.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)

  IF ISFALSE(RegisterClassEx(wce)) THEN
      RegisterClass BYVAL (VARPTR(wce) + 4)
  END IF

  hMenu       = LoadMenu(hInstance, "MAINMENU")           'main menu
  hMenuFile   = GetSubMenu(hMenu, 0)                      'File menu
  hMenuReopen = GetSubMenu(hMenuFile, 2)                  'Reopen files submenu
  hMenuEdit   = GetSubMenu(hMenu, 1)                      'Edit menu
  hMenuWindow = GetSubMenu(hMenu, 2)                      'Window menu

  ' Create main window using the registered class
  hWndMain = CreateWindow("EPBNOTE2", _              ' window class name
                          "EPBNOTE2", _              ' window caption
                          %WS_OVERLAPPEDWINDOW, _   ' window style
                          (GetSystemMetrics(%SM_CXSCREEN) - 640) / 2, _  ' initial x position
                          (GetSystemMetrics(%SM_CYSCREEN) - 480) / 2, _  ' initial y position
                          640, _                    ' initial x size
                          480, _                    ' initial y size
                          %NULL, _                  ' parent window handle
                          hMenu, _                  ' window menu handle
                          hInstance, _              ' program instance handle
                          BYVAL %NULL)              ' creation parameters

  hAccel = LoadAccelerators(hInstance, "EPBNOTE2")

  ShowWindow hWndMain, iCmdShow
  UpdateWindow hWndMain

  ' Message handler loop
  WHILE GetMessage(Msg, BYVAL %NULL, 0, 0)
     IF TranslateMDISysAccel(hWndClient, Msg) = 0 THEN
        IF TranslateAccelerator(hWndMain, hAccel, Msg) = 0 THEN
           TranslateMessage Msg
           DispatchMessage Msg
        END IF
     END IF
  WEND

  FUNCTION = msg.wParam
END FUNCTION  ' end WinMain

'------------------------------------------------------------------------------
' Main procedure
'------------------------------------------------------------------------------
FUNCTION WndProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                  BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG

  LOCAL ToolHeight  AS LONG
  LOCAL StatHeight  AS LONG
  LOCAL dwProc      AS DWORD
  LOCAL hLib        AS DWORD
  LOCAL hMdi        AS DWORD
  LOCAL Style       AS DWORD
  LOCAL f           AS STRING
  LOCAL Path        AS STRING
  LOCAL pt          AS POINTAPI
  LOCAL tRect       AS RECT
  LOCAL mii         AS MENUITEMINFO
  LOCAL tbn         AS TBNOTIFY PTR
  LOCAL lpToolTip   AS TOOLTIPTEXT PTR
  LOCAL cc          AS CLIENTCREATESTRUCT
  LOCAL iccex       AS INIT_COMMON_CONTROLSEX
  LOCAL zText       AS ASCIIZ * %MAX_PATH

  SELECT CASE wMsg
     CASE %WM_CREATE
        '------------------------------------------------------------------------
        ' some of CommCtrl.dll's controls, messages and styles were not included
        ' in standard Win95A release, so we need to see how to initiate the dll.
        '------------------------------------------------------------------------
        NewComCtl = InitComctl32 (%ICC_BAR_CLASSES)
        '------------------------------------------------------------------------

        DIM tbb(8) AS TBBUTTON  'for 9 buttons, including separators

        ' Fill the TBBUTTON array with button information
        tbb(0).iBitmap   = %STD_FILENEW     : tbb(0).idCommand = %IDM_NEW
        tbb(0).fsState   = %TBSTATE_ENABLED : tbb(0).fsStyle   = %TBSTYLE_BUTTON

        tbb(1).iBitmap   = %STD_FILEOPEN    : tbb(1).idCommand = %IDM_OPEN
        tbb(1).fsState   = %TBSTATE_ENABLED
        IF NewComCtl THEN
           tbb(1).fsStyle = %TBSTYLE_DROPDOWN
        ELSE
           tbb(1).fsStyle = %TBSTYLE_BUTTON
        END IF

        tbb(2).iBitmap   = %STD_FILESAVE      : tbb(2).idCommand = %IDM_SAVE
        tbb(2).fsState   = %TBSTATE_ENABLED   : tbb(2).fsStyle   = %TBSTYLE_BUTTON

        tbb(3).iBitmap   = 0                  : tbb(3).idCommand = 701
        tbb(3).fsState   = %TBSTATE_ENABLED   : tbb(3).fsStyle   = %TBSTYLE_SEP

        tbb(4).iBitmap   = %STD_CUT           : tbb(4).idCommand = %IDM_CUT
        tbb(4).fsState   = %TBSTATE_ENABLED   : tbb(4).fsStyle   = %TBSTYLE_BUTTON

        tbb(5).iBitmap   = %STD_COPY          : tbb(5).idCommand = %IDM_COPY
        tbb(5).fsState   = %TBSTATE_ENABLED   : tbb(5).fsStyle   = %TBSTYLE_BUTTON

        tbb(6).iBitmap   = %STD_PASTE         : tbb(6).idCommand = %IDM_PASTE
        tbb(6).fsState   = %TBSTATE_ENABLED   : tbb(6).fsStyle   = %TBSTYLE_BUTTON

        tbb(7).iBitmap   = 0                  : tbb(7).idCommand = 702
        tbb(7).fsState   = %TBSTATE_ENABLED   : tbb(7).fsStyle   = %TBSTYLE_SEP

        tbb(8).iBitmap   = %STD_UNDO          : tbb(8).idCommand = %IDM_UNDO
        tbb(8).fsState   = %TBSTATE_ENABLED   : tbb(8).fsStyle   = %TBSTYLE_BUTTON

        ' Create the status bar window
        hStatus = CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE OR %SBS_SIZEGRIP, _
                                   "", hWnd, %ID_STATUSBAR)

        'set up a couple of statusbar parts
        REDIM prts(1) AS LONG
        prts(0) = 200 : prts(1) = -1
        Sendmessage hStatus, %SB_SETPARTS, 2, VARPTR(prts(0))
        SendMessage hStatus, %SB_SETTEXT, 0 OR %SBT_NOBORDERS, VARPTR(zText)

        ' Create the toolbar window
        hToolbar = CreateToolbarEx(hWnd, %WS_CHILD OR %TBSTYLE_TOOLTIPS, _
                                 %ID_TOOLBAR, 12, %HINST_COMMCTRL, %IDB_STD_SMALL_COLOR, _
                                 tbb(0), UBOUND(tbb) + 1, 0, 0, 100, 30, LEN(TBBUTTON))

        ' Create MDI Client window
        cc.idFirstChild = 1
        cc.hWindowMenu  = hMenuWindow  'for file list in Window menu
        hWndClient = CreateWindowEx(%WS_EX_CLIENTEDGE, "MDICLIENT", BYVAL %NULL, _
                                    %WS_CHILD OR %WS_CLIPCHILDREN OR _
                                    %WS_VISIBLE OR %WS_VSCROLL OR %WS_HSCROLL, _
                                    0, 0, 0, 0, hWnd, 1, hInst, cc)

        ' Display the toolbar
        SendMessage hToolbar, %TB_AUTOSIZE, 0, 0
        IF NewComCtl THEN ' then we can use more modern features, like flat style, etc.
           SetWindowLong hToolbar, %GWL_STYLE, _
                         GetWindowLong(hToolbar, %GWL_STYLE) OR %TBSTYLE_FLAT
           SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
        END IF
        ShowWindow hToolbar, %SW_SHOW

        GetRecentFiles    ' fill the Recent files menu (MRU) ..
        HideButtons %TRUE
        EXIT FUNCTION

     CASE %WM_SIZE
        IF wParam <> %SIZE_MINIMIZED THEN
           GetWindowRect hToolbar, tRect
           ToolHeight = tRect.nBottom - tRect.nTop  'toolbar height
           GetWindowRect hStatus, tRect
           StatHeight = tRect.nBottom - tRect.nTop  'statusbar height

           SendMessage hStatus, wMsg, wParam, lParam
           SendMessage hToolbar, wMsg, wParam, lParam
           MoveWindow hWndClient, -2, ToolHeight, LOWRD(lParam) + 4, _
                      HIWRD(lParam) - (ToolHeight + StatHeight), %TRUE
        END IF
        EXIT FUNCTION

     CASE %WM_NOTIFY
        tbn = lParam
        IF @tbn.hdr.code = %TTN_NEEDTEXT THEN
           lpToolTip = lParam
           LoadString hInst, @lpToolTip.hdr.idFrom, zText, SIZEOF(zText)
           @lpToolTip.lpszText = VARPTR(zText)

        ELSEIF NewComCtl AND @tbn.hdr.code = %TBN_DROPDOWN THEN
           SELECT CASE @tbn.iItem
              CASE %IDM_OPEN
                 CALL SendMessage(@tbn.hdr.hwndFrom, %TB_GETRECT, @tbn.iItem, VARPTR(tRect))
                 CALL MapWindowPoints(@tbn.hdr.hwndFrom, %HWND_DESKTOP, BYVAL VARPTR(tRect), 2)
                 CALL TrackPopupMenu (hMenuReopen, 0, tRect.nLeft, tRect.nBottom, 0, hWnd, BYVAL %NULL)
           END SELECT
        END IF
        EXIT FUNCTION

     CASE %WM_MENUSELECT
        LoadString hInst, wParam, zText, SIZEOF(zText)
        SendMessage hStatus, %SB_SETTEXT, 0 OR %SBT_NOBORDERS, VARPTR(zText)
        EXIT FUNCTION

     CASE %WM_NCPAINT 'if flag is set, return zero to avoid menu update
        IF freezeMenu THEN EXIT FUNCTION

     CASE %WM_COMMAND
        SELECT CASE LOWRD(wParam)
           CASE %IDM_NEW
              IF MdiGetActive(hWndClient) AND _ 'if not first doc and docs are maximized
                 IsZoomed(MdiGetActive(hWndClient)) THEN freezeMenu = 1

              hMdi = CreateMdiChild("EPBNOTE32", hWndClient, "", %WS_MAXIMIZE)

              IF freezeMenu THEN 'now time to redraw menu
                 freezeMenu = 0
                 DrawMenuBar hWndMain
              END IF
              EXIT FUNCTION

           CASE %IDM_OPEN
               Path  = CURDIR$
               f     = "*.kry"
               Style = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               IF OpenFileDialog(hWndMain, "", f, Path, _
                                 "Crypted Files|*.kry|All Files|*.*", "kry", Style) THEN

                  InvalidateRect hToolBar, BYVAL %NULL, 0 : UpdateWindow hToolBar
                  OpenThisFile f
                  EXIT FUNCTION
               END IF

           CASE %IDM_RECENT1 TO %IDM_RECENT8      'MRU menu items (file names)
              mii.cbSize = SIZEOF(mii)            'size of structure
              mii.fMask  = %MIIM_TYPE OR %MIIM_ID 'set mask
              mii.fType  = %MFT_STRING
              mii.wID    = LOWRD(wParam)          'selected item
              mii.cch    = %MAX_PATH              'max length of string
              f = SPACE$(mii.cch)                 'allocate enough string space
              mii.dwTypeData = STRPTR(f)          'point to allocated string

              GetMenuItemInfo hMenuReopen,mii.wID,0&,mii  'get string
              f = EXTRACT$(f, CHR$(0))            'cut at zero ending
              f = MID$(f, 4)                      'remove first part - item number
              OpenThisFile f                      'open selected file

           CASE %IDM_SAVE   : SaveFile %FALSE
           CASE %IDM_SAVEAS : SaveFile %TRUE
           CASE %IDM_EXIT   : SendMessage hWnd, %WM_CLOSE, wParam, lParam

           CASE %IDM_UNDO    : SendMessage GetEdit, %EM_UNDO, 0, 0
           CASE %IDM_CUT     : SendMessage GetEdit, %WM_CUT, 0, 0
           CASE %IDM_COPY    : SendMessage GetEdit, %WM_COPY, 0, 0
           CASE %IDM_PASTE   : SendMessage GetEdit, %WM_PASTE, 0, 0
           CASE %IDM_DELETE  : SendMessage GetEdit, %WM_CLEAR, 0, 0
           CASE %IDM_SELALL  : SendMessage GetEdit, %EM_SETSEL, 0, -1

           CASE %IDM_CASCADE : MdiCascade hWndClient
           CASE %IDM_TILEH   : MdiTile hWndClient, %MDITILE_HORIZONTAL
           CASE %IDM_TILEV   : MdiTile hWndClient, %MDITILE_VERTICAL
           CASE %IDM_ARRANGE : MdiIconArrange hWndClient
           CASE %IDM_CLOSE
              WHILE MdiGetActive(hWndClient)
                 CALL SendMessage(MdiGetActive(hWndClient), %WM_CLOSE, 0, 0)
                 IF fClosed = 0 THEN EXIT FUNCTION
              WEND

           CASE %IDM_ABOUT
               dwProc = CODEPTR(AboutProc)
               DialogBox hInst, "ABOUT", hWnd, dwProc

        END SELECT

     CASE %WM_CLOSE
        WHILE MdiGetActive(hWndClient)
           CALL SendMessage(MdiGetActive(hWndClient), %WM_CLOSE, 0, 0)
           IF fClosed = 0 THEN EXIT FUNCTION
        WEND

     CASE %WM_SYSCOLORCHANGE
        ' Forward this message to common controls so that they will
        ' be properly updated if the user changes the color settings.
        SendMessage hToolBar,  %WM_SYSCOLORCHANGE, wParam, lParam
        SendMessage hStatus,  %WM_SYSCOLORCHANGE, wParam, lParam

     CASE %WM_DESTROY
        PostQuitMessage 0
        EXIT FUNCTION

  END SELECT

  FUNCTION = DefFrameProc(hWnd, hWndClient, wMsg, wParam, lParam)
END FUNCTION

'------------------------------------------------------------------------------
' NotePad procedure - handle messages from the MDI child windows.
'------------------------------------------------------------------------------
FUNCTION CodeProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                   BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG

  LOCAL nFile  AS LONG
  LOCAL dwRes  AS DWORD
  LOCAL hEdit  AS DWORD
  LOCAL hFont  AS DWORD
  LOCAL Buffer AS STRING
  LOCAL pt     AS POINTAPI
  LOCAL rc     AS RECT
  LOCAL zText  AS ASCIIZ * %MAX_PATH

  SELECT CASE wMsg
     CASE %WM_CREATE
        GetClientRect hWnd, rc
        hEdit = CreateWindowEx(0, "Edit", BYVAL %NULL, %WS_CHILD OR %WS_VISIBLE OR _
                               %ES_MULTILINE OR %WS_VSCROLL OR %WS_HSCROLL OR _
                               %ES_AUTOHSCROLL OR %ES_AUTOVSCROLL OR %ES_NOHIDESEL, _
                               0, 0, rc.nRight, rc.nBottom, hWnd, %IDC_EDIT, hInst, BYVAL %NULL)

        hFont = GetStockObject(%ANSI_FIXED_FONT)
        SendMessage hEdit, %WM_SETFONT, hFont, 0
        IF isNT = 0 THEN 'in 16/32-bit systems like Win95/98, limit is 65535 bytes
           SendMessage hEdit, %EM_SETLIMITTEXT, 65535, 0
        END IF

        GetWindowText hWnd, zText, SIZEOF(zText)
        IF LEN(zText) THEN
            nFile = FREEFILE
            OPEN zText FOR BINARY AS nFile LEN = 8192
            IF ERR THEN
               BEEP
               DestroyWindow hWnd
               EXIT FUNCTION
            END IF

            GET$ nFile, LOF(nFile), Buffer
            CLOSE nFile

        ' if this is a .kry file then we decrypt it

        IF RIGHT$(zText,4)=".kry" THEN
        '-------------------------------------
        'PC1 decryption
        'ask the password
        password = INPUTBOX$("Enter the password (16 chars maxi)",, "Top secret")
        Buffer = PC1DEC(password,Buffer)
        '-------------------------------------

        END IF

            SetWindowText hEdit, BYVAL STRPTR(Buffer)
            WriteRecentFiles zText  ' refresh reopen file list

        ELSE
           INCR NewDocNum
           SetWindowText hWnd, "Untitled" & STR$(NewDocNum)
        END IF

        IF MdiGetActive(hWndClient) = 0 THEN HideButtons 0 'if first doc
        EXIT FUNCTION

     CASE %WM_SIZE
        hEdit = GetDlgItem(hWnd, %IDC_EDIT)
        MoveWindow hEdit, 0, 0, LOWRD(lParam), HIWRD(lParam), 1
        SendMessage hEdit, %EM_GETRECT, 0, VARPTR(rc) 'for margins in editor
        rc.nTop  = 2 ' pixels, top margin
        rc.nLeft = 3 ' pixels, left margin
        rc.nBottom = rc.nBottom + 2 ' increase bottom part a bit
        SendMessage hEdit, %EM_SETRECTNP, 0, BYVAL VARPTR(rc)

     CASE %WM_SETFOCUS
        SetFocus GetEdit
        EXIT FUNCTION

     CASE %WM_CLOSE
        IF SendMessage(GetEdit, %EM_GETMODIFY, 0, 0) THEN
            GetWindowText hWnd, zText, SIZEOF(zText)

            Buffer = "Save changes to " & FileNam(zText) & " ?"
            dwRes  = MessageBox(hWnd, BYVAL STRPTR(Buffer), "EPBNOTE2", _
                                %MB_YESNOCANCEL OR %MB_ICONEXCLAMATION)

            IF dwRes = %IDCANCEL THEN
                fClosed = %FALSE
                EXIT FUNCTION
            ELSEIF dwRes = %IDYES THEN
                SaveFile %FALSE
            END IF
        END IF
        fClosed = %TRUE

        dwRes = GetWindow(hWndClient, %GW_CHILD)
        IF GetWindow(dwRes, %GW_HWNDNEXT) = 0 THEN 'if this is last doc
           HideButtons %TRUE
        END IF

     CASE %WM_DESTROY
        IF MdiGetActive(hWndClient) = 0 THEN 'if last one closed
           NewDocNum = 0                     'reset doc counter
        END IF

  END SELECT

  FUNCTION = DefMDIChildProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'------------------------------------------------------------------------------
' About box dialog procedure
'------------------------------------------------------------------------------
FUNCTION AboutProc (BYVAL hDlg AS DWORD, BYVAL wMsg AS DWORD, _
                    BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG

  SELECT CASE wMsg
     CASE %WM_INITDIALOG
        CenterWindow hDlg
        EnableWindow hWndMain, %FALSE
        FUNCTION = 1

     CASE %WM_COMMAND
        SELECT CASE LOWRD(wParam)
           CASE %IDCANCEL
              EndDialog hDlg, 0
              EnableWindow hWndMain, %TRUE
              FUNCTION = 1

           CASE %IDOK, 103
              EndDialog hDlg, 1
              EnableWindow hWndMain, %TRUE
              FUNCTION = 1
        END SELECT
  END SELECT

END FUNCTION

'------------------------------------------------------------------------------
' Center a window on screen
'------------------------------------------------------------------------------
SUB CenterWindow (BYVAL hWnd AS DWORD)
  LOCAL rc AS RECT

  GetWindowRect hWnd, rc
  rc.nLeft = (GetSystemMetrics(%SM_CXSCREEN) - (rc.nRight - rc.nLeft)) \ 2
  rc.nTop = (GetSystemMetrics(%SM_CYSCREEN) - _
            (rc.nBottom - rc.nTop + GetSystemMetrics(%SM_CYCAPTION))) \ 2

  SetWindowPos hWnd, %NULL, rc.nLeft, rc.nTop, 0, 0, %SWP_NOSIZE OR %SWP_NOZORDER

END SUB

'------------------------------------------------------------------------------
' FileExist - make sure a file or folder exists
'------------------------------------------------------------------------------
FUNCTION FileExist(BYVAL sfName AS STRING) AS LONG
  LOCAL hRes AS DWORD, tWFD AS WIN32_FIND_DATA

  IF LEN(sfName) = 0 THEN EXIT FUNCTION       'no need to continue then..
  IF ASC(sfName, -1) = 92 THEN                'if a path with trailing backslash
     sfName = LEFT$(sfName, LEN(sfName) - 1)  'remove trailing backslash
  END IF

  hRes = FindFirstFile(BYVAL STRPTR(sfName), tWFD)
  IF hRes <> %INVALID_HANDLE_VALUE THEN
     FUNCTION = %TRUE
     FindClose hRes
  END IF
END FUNCTION

'------------------------------------------------------------------------------
' Get file name part of given path & name
'------------------------------------------------------------------------------
FUNCTION FileNam (BYVAL Src AS STRING) AS STRING
  LOCAL x AS LONG

  x = INSTR(-1, Src, ANY ":/\")
  IF x THEN
      FUNCTION = MID$(Src, x + 1)
  ELSE
      FUNCTION = Src
  END IF

END FUNCTION

'------------------------------------------------------------------------------
' Get path -part of given path & name
'------------------------------------------------------------------------------
FUNCTION FilePath (BYVAL Src AS STRING) AS STRING
  LOCAL x AS LONG

  x = INSTR(-1, Src, ANY ":\/")
  IF x THEN FUNCTION = LEFT$(Src, x)

END FUNCTION

'------------------------------------------------------------------------------
' Get active MDI child's edit control, if any
'------------------------------------------------------------------------------
FUNCTION GetEdit() AS LONG
  FUNCTION = GetDlgItem(MdiGetActive(hWndClient), %IDC_EDIT)
END FUNCTION

'------------------------------------------------------------------------------
' Read the list of recently opened files
'------------------------------------------------------------------------------
SUB GetRecentFiles
  LOCAL Bc AS LONG, lRes AS LONG
  LOCAL mii AS MENUITEMINFO, InString AS ASCIIZ * 300
  LOCAL zSection AS ASCIIZ * 30, zKey AS ASCIIZ * 30, zDefault AS ASCIIZ * 30

  FOR Bc = GetMenuItemCount(hMenuReopen) - 1 TO 0 STEP - 1 'clear menu
     IF RemoveMenu(hMenuReopen, Bc, %MF_BYPOSITION) = 0 THEN EXIT FOR
  NEXT Bc
  CALL DrawMenuBar(hWndMain)

  Bc = 1
  zSection = "Reopen files"
  mii.cbSize = SIZEOF(mii)
  mii.fMask  = %MIIM_TYPE OR %MIIM_ID OR %MIIM_SUBMENU
  mii.fType  = %MFT_STRING
  DO
     zKey = "File " & FORMAT$(Bc)
     lRes = GetPrivateProfileString(zSection, zKey, zDefault, InString, %MAX_PATH, iniFile)

     IF lRes THEN
        InString = "&" & FORMAT$(Bc) & " " & TRIM$(EXTRACT$(InString, CHR$(0)))
        mii.wID        = %IDM_RECENT1 + Bc - 1
        mii.dwTypeData = VARPTR(InString)
        mii.cch        = LEN(InString)
        InsertMenuItem hMenuReopen, Bc, %TRUE, mii
     ELSE
        EXIT DO
     END IF
     INCR Bc
     IF Bc > 8 THEN EXIT DO
  LOOP

END SUB

'------------------------------------------------------------------------------
' Show/hide buttons and enable/disable menus
'------------------------------------------------------------------------------
SUB HideButtons(BYVAL HideState AS LONG)
  LOCAL item AS DWORD, mFlag AS DWORD

  IF GetSubMenu(hMenu, 0) = hMenuFile THEN item = 1 ELSE item = 2
  IF HideState THEN mFlag = %MF_GRAYED ELSE mFlag = %MF_ENABLED

  EnableMenuItem hMenu, item, %MF_BYPOSITION OR mFlag
  EnableMenuItem hMenu, item + 1, %MF_BYPOSITION OR mFlag
  EnableMenuItem hMenuFile, %IDM_SAVE,    %MF_BYCOMMAND OR mFlag
  EnableMenuItem hMenuFile, %IDM_SAVEAS,  %MF_BYCOMMAND OR mFlag
  DrawMenuBar hWndMain

  SendMessage hToolbar, %TB_HIDEBUTTON, %IDM_UNDO, HideState
  SendMessage hToolbar, %TB_HIDEBUTTON, 702, HideState
  SendMessage hToolbar, %TB_HIDEBUTTON, %IDM_PASTE, HideState
  SendMessage hToolbar, %TB_HIDEBUTTON, %IDM_COPY, HideState
  SendMessage hToolbar, %TB_HIDEBUTTON, %IDM_CUT, HideState
  SendMessage hToolbar, %TB_HIDEBUTTON, 701, HideState
  SendMessage hToolbar, %TB_HIDEBUTTON, %IDM_SAVE, HideState

END SUB

'------------------------------------------------------------------------------
' Initialize comctl32.dll - return 1 if InitCommonControlsEx was used.
' Here we use LoadLibrary and GetProcAddress to avoid crash on failure.
' Example use:  NewComCtl = InitComctl32 (%ICC_BAR_CLASSES)
'------------------------------------------------------------------------------
FUNCTION InitComctl32 (BYVAL iccClasses AS DWORD ) AS LONG
   LOCAL hLib     AS DWORD
   LOCAL dwProc   AS DWORD
   LOCAL iccex    AS INIT_COMMON_CONTROLSEX

   hLib = LoadLibrary("COMCTL32.DLL")
   IF hLib THEN
      dwProc = GetProcAddress(hLib, "InitCommonControlsEx")
      IF dwProc THEN
         FUNCTION = 1                  'return 1 on success
         iccex.dwSize = SIZEOF(iccex)  'fill the iccex structure
         iccex.dwICC  = iccClasses     'tell what classes to initiate
         CALL DWORD dwProc USING zInitCommonControlsEx(iccex)
      ELSE
         InitCommonControls
      END IF
      CALL FreeLibrary(hLib) 'we can FreeLibrary now, because InitCommonControls(Ex)
   END IF                    'has made sure comctl32.dll is loaded into the system.

END FUNCTION

'------------------------------------------------------------------------------
' Open file procedure
'------------------------------------------------------------------------------
FUNCTION OpenThisFile(BYVAL fn AS STRING) AS DWORD
  LOCAL hMdi AS DWORD, zText AS ASCIIZ * %MAX_PATH

  hMdi = GetWindow(hWndClient, %GW_CHILD) 'first look at already opened docs
  WHILE hMdi
     GetWindowText hMdi, zText, %MAX_PATH
     IF UCASE$(zText) = UCASE$(fn) THEN                   'if already opened
        SendMessage hWndClient, %WM_MDIACTIVATE, hMdi, 0  'activate it
        WriteRecentFiles fn                               'update MRU menu and exit
        EXIT FUNCTION
     END IF
     hMdi = GetWindow(hMdi, %GW_HWNDNEXT)
  WEND
  '------------------------------------------------------------------------------
  IF MdiGetActive(hWndClient) AND _      'if not first doc and docs are maximized
     IsZoomed(MdiGetActive(hWndClient)) THEN freezeMenu = 1 'turn off menu redraw

  hMdi = CreateMdiChild("EPBNOTE32", hWndClient, fn, %WS_MAXIMIZE)

  IF freezeMenu THEN       'if menu redraw was turned off
     freezeMenu = 0        'reset flag
     DrawMenuBar hWndMain  'and redraw menu
  END IF

  FUNCTION = hMdi
END FUNCTION

'------------------------------------------------------------------------------
' Save as -procedure
'------------------------------------------------------------------------------
SUB SaveFile (BYVAL Ask AS LONG)
  LOCAL Style  AS DWORD
  LOCAL nFile  AS DWORD
  LOCAL Path   AS STRING
  LOCAL f      AS STRING
  LOCAL Buffer AS STRING
  LOCAL zText  AS ASCIIZ * %MAX_PATH

  GetWindowText MdiGetActive(hWndClient), zText, SIZEOF(zText)
  IF INSTR(zText, ANY ":\/") = 0 THEN 'if no path, it's a new doc
      Path = CURDIR$
      IF RIGHT$(Path, 1) <> "\" THEN Path = Path + "\"
      f    = zText & ".kry"  'suggest this name
      Ask  = %TRUE           'we need the dialog for new docs
  ELSE
      ' we use the default .kry extension when we save a document
      IF RIGHT$(zText,4)<>".kry" THEN MID$(zText,LEN(zText)-3,4)=".kry"
      Path = FilePath(zText)
      f    = FileNam(zText)
  END IF

  Style = %OFN_HIDEREADONLY OR %OFN_LONGNAMES

  IF Ask THEN
         IF SaveFileDialog(hWndMain, "", f, Path, _
         "Crypted Files|*.kry|All Files|*.*", "kry", Style) = 0 THEN EXIT SUB
  ELSE
     f = Path & f
  END IF

  nFile = FREEFILE  'time to save the file
  OPEN f FOR BINARY AS nFile
     IF ERR THEN  'if something went wrong
        BEEP      'we should flash a message, but..
        EXIT SUB
     END IF

     Buffer = SPACE$(GetWindowTextLength(GetEdit) + 1)

     GetWindowText GetEdit, BYVAL STRPTR(Buffer), LEN(Buffer)

    '-------------------------------------
    'PC1 encryption
    'ask the password
    password = INPUTBOX$("Enter the password (16 chars maxi)",, "Top secret")
    Buffer = PC1ENC(password,Buffer)
    '-------------------------------------

     PUT$ nFile, LEFT$(Buffer, LEN(Buffer) - 1)
     SETEOF nFile
  CLOSE nFile

  IF Ask THEN 'if dialog, update caption in case name was changed
     SetWindowText MdiGetActive(hWndClient), BYVAL STRPTR(f)
  END IF
  SendMessage GetEdit, %EM_SETMODIFY, 0, 0
  WriteRecentFiles f   'finally, update reopen file list (MRU menu)

END SUB

'------------------------------------------------------------------------------
' Save the list of recently opened files
'------------------------------------------------------------------------------
SUB WriteRecentFiles (BYVAL OpenFName AS STRING)
  LOCAL Ac AS LONG, dwRes AS DWORD, zText AS ASCIIZ * %MAX_PATH
  LOCAL zSection AS ASCIIZ * 30, zKey AS ASCIIZ * 30, zDefault AS ASCIIZ * 30

  DIM IniName(1 : 8) AS STRING
  zSection = "Reopen files"

  FOR Ac = 1 TO 8
     zKey = "File " & FORMAT$(Ac)
     dwRes = GetPrivateProfileString(zSection, zKey, zDefault, zText, %MAX_PATH, iniFile)
     IF dwRes THEN IniName(Ac) = LEFT$(zText, dwRes)
  NEXT Ac

  Ac = 0
  ARRAY SCAN IniName(), COLLATE UCASE, = UCASE$(OpenFName), TO Ac
  IF Ac THEN ARRAY DELETE IniName(Ac)
  ARRAY INSERT IniName(), OpenFName

  FOR Ac = 1 TO 8
     IF LEN(IniName(Ac)) THEN
        zKey   = "File " & FORMAT$(Ac)
        zText = IniName(Ac)
        WritePrivateProfileString zSection, zKey, zText, iniFile
     END IF
  NEXT Ac

  GetRecentFiles 'update MRU menu

END SUB

'--------------------------------------------------------
' PC1 Encryption/decryption cipher
'--------------------------------------------------------

SUB code()
ON ERROR RESUME NEXT
dx = (x1a2 + I) MOD 65536
ax = x1a0(I)
cx = &H15A
bx = &H4E35
tmp = ax
ax = si
si = tmp
tmp = ax
ax = dx
dx = tmp
IF (ax <> 0) THEN
ax = (ax * bx) MOD 65536
END IF
tmp = ax
ax = cx
cx = tmp
IF (ax <> 0) THEN
ax = (ax * si) MOD 65536
cx = (ax + cx) MOD 65536
END IF
tmp = ax
ax = si
si = tmp
ax = (ax * bx) MOD 65536
dx = (cx + dx) MOD 65536
ax = ax + 1
x1a2 = dx
x1a0(I) = ax
res = ax XOR dx
I = I + 1
END SUB
SUB Assemble()
ON ERROR RESUME NEXT
x1a0(0) = ((cle(1) * 256) + cle(2)) MOD 65536
code
inter = res
x1a0(1) = x1a0(0) XOR ((cle(3) * 256) + cle(4))
code
inter = inter XOR res
x1a0(2) = x1a0(1) XOR ((cle(5) * 256) + cle(6))
code
inter = inter XOR res
x1a0(3) = x1a0(2) XOR ((cle(7) * 256) + cle(8))
code
inter = inter XOR res
x1a0(4) = x1a0(3) XOR ((cle(9) * 256) + cle(10))
code
inter = inter XOR res
x1a0(5) = x1a0(4) XOR ((cle(11) * 256) + cle(12))
code
inter = inter XOR res
x1a0(6) = x1a0(5) XOR ((cle(13) * 256) + cle(14))
code
inter = inter XOR res
x1a0(7) = x1a0(6) XOR ((cle(15) * 256) + cle(16))
code
inter = inter XOR res
I = 0
END SUB

FUNCTION PC1ENC(encPassword AS STRING, encStringOut AS STRING) EXPORT AS STRING
ON ERROR RESUME NEXT
DIM encStringIn AS STRING
DIM fois AS LONG
DIM champ1 AS STRING
DIM lngchamp1 AS LONG
DIM cfc AS LONG, cfd AS LONG
DIM compte AS LONG
DIM c AS LONG, D AS LONG, E AS LONG
REDIM x1a0(9) AS LONG
REDIM cle(17) AS LONG
encStringIn = ""
si = 0
x1a2 = 0
I = 0
FOR fois = 1 TO 16
cle(fois) = 0
NEXT fois
champ1 = encPassword
lngchamp1 = LEN(champ1)
FOR fois = 1 TO lngchamp1
cle(fois) = ASC(MID$(champ1, fois, 1))
NEXT fois
champ1 = encStringOut
lngchamp1 = LEN(champ1)
FOR fois = 1 TO lngchamp1
c = ASC(MID$(champ1, fois, 1))
Assemble
cfc = (((inter / 256) * 256) - (inter MOD 256)) / 256
cfd = inter MOD 256
FOR compte = 1 TO 16
cle(compte) = cle(compte) XOR c
NEXT compte
c = c XOR (cfc XOR cfd)
'D = (((c / 16) * 16) - (c MOD 16)) / 16
'E = c MOD 16
'encStringIn = encStringIn + CHR$(&H61 + D) ' d+&h61 give one letter range from a to p for the 4 high bits of c
'encStringIn = encStringIn + CHR$(&H61 + E) ' e+&h61 give one letter range from a to p for the 4 low bits of c
encStringIn = encStringIn + CHR$(c)
NEXT fois
PC1ENC = encStringIn
END FUNCTION

FUNCTION PC1DEC(encPassword AS STRING, encStringIn AS STRING) EXPORT AS STRING
ON ERROR RESUME NEXT
DIM encStringOut AS STRING
DIM fois AS LONG
DIM champ1 AS STRING
DIM lngchamp1 AS LONG
DIM cfc AS LONG, cfd AS LONG
DIM compte AS LONG
DIM c AS LONG, D AS LONG, E AS LONG
REDIM x1a0(9) AS LONG
REDIM cle(17) AS LONG
encStringOut = ""
si = 0
x1a2 = 0
I = 0
FOR fois = 1 TO 16
cle(fois) = 0
NEXT fois
champ1 = encPassword
lngchamp1 = LEN(champ1)
FOR fois = 1 TO lngchamp1
cle(fois) = ASC(MID$(champ1, fois, 1))
NEXT fois
champ1 = encStringIn
lngchamp1 = LEN(champ1)
FOR fois = 1 TO lngchamp1
C = ASC(MID$(champ1,fois,1))
'D = ASC(MID$(champ1, fois, 1))
'IF (D - &H61) >= 0 THEN
'D = D - &H61  ' to transform the letter to the 4 high bits of c
'IF (D >= 0) AND (D <= 15) THEN
'D = D * 16
'END IF
'END IF
'IF (fois <> lngchamp1) THEN
'fois = fois + 1
'END IF
'E = ASC(MID$(champ1, fois, 1))
'IF (E - &H61) >= 0 THEN
'E = E - &H61 ' to transform the letter to the 4 low bits of c
'IF (E >= 0) AND (E <= 15) THEN
'c = D + E
'END IF
'END IF
Assemble
cfc = (((inter / 256) * 256) - (inter MOD 256)) / 256
cfd = inter MOD 256
c = c XOR (cfc XOR cfd)
FOR compte = 1 TO 16
cle(compte) = cle(compte) XOR c
NEXT compte
encStringOut = encStringOut + CHR$(c)
NEXT fois
PC1DEC = encStringOut
END FUNCTION

'------------------------------------------------------------------------------
